<?php

//      mes_fonctions.php  EspFor 2.4 le 27 mai 2007 par Pascal Choteau

// filtre pdf_first_clean, CONTRIBUTION sur Spip-contrib "Génération améliorée de fichiers PDF"  par Jérôme Fenal
function pdf_first_clean($texte) {
        // $texte = ereg_replace("<p class[^>]*>", "<P>", $texte);
        //Translation des codes iso
        // PB avec l'utilisation de <code>
        $trans = get_html_translation_table(HTML_ENTITIES);
        $trans = array_flip($trans);
        $trans["<br />\n"] = "<BR>";        // Pour eviter que le \n ne se transforme en espace dans les <DIV class=spip_code> (TT, tag SPIP : code)
        $trans["œ"] = "oe";
        $trans["-"] = "-";
        $trans["'"] = "'";
        $trans['"'] = "\"";
        $trans["&ucirc;"] = "û";
         $trans['$'] = '\$';
        $trans['->'] = '-»';
        $trans['<-'] = '«-';
        $texte = strtr($texte, $trans);

        // Echappement des "
         $texte = ereg_replace("\"", "\\\"", $texte);

        // Traitement des Espaces
        $texte = ereg_replace("(&nbsp;| )+", " ", $texte);

        // Traitement des cadres
        $trans=array("\n" => '<BR>');
        while (preg_match('/(.*<textarea[^>]*>)(.*\n.*)(<\/textarea>.*)/ims', $texte, $textarea)) {
                $rep=strtr($textarea[2], $trans);
                $texte=$textarea[1].$rep.$textarea[3];
        }

        return $texte;
}

/*
 *   +----------------------------------+
 *    Nom des Filtres :    google_like
 *   +----------------------------------+
 *    Date : 23 Mars 2005
 *    Créé le 28 septembre 2004 : Nicolas Steinmetz,  pdepaepe
 *    Modifié le 21 mai 2007 : Par Pascal Choteau pour surligner avec l'attribut css spip_surligne de spip
 *   +-------------------------------------+
 *    Fonctions de ce filtre : Afficher les résultats de recherche à la google
 *   +-------------------------------------+
*/
function google_like($string) {
	$string = textebrut($string);
	$query = rtrim(str_replace("+", " ", $_GET['recherche']));
	//suppression de moins de 3 caractères
	$query = preg_replace('@(.+?)\b[\w]{1,2}\b(.+?)@i', '\1 \2', $query);
	$qt = explode(" ", $query);
	$num = count ($qt);
	$cc = ceil(200 / $num);
		for ($i = 0; $i < $num; $i++) {
			$tab2[$i] = preg_split("/($qt[$i])/i",$string,2, PREG_SPLIT_DELIM_CAPTURE);
			if(count($tab2[$i])>1){
				$avant[$i] = substr($tab2[$i][0],-$cc,$cc);
	    	    	        $apres[$i] = substr($tab2[$i][2],0,$cc);
		    	        $string_re .= "[...] $avant[$i]<span class=\"spip_surligne\">".$tab2[$i][1]."</span>$apres[$i] [...] ";
	       }
	 }
	 return $string_re;
}

// filtre surligne_titre, permet de surligner les mots d'un titre correspondant à la recherche (quand var_recherche et DEBUT_SURLIGNE ne sont pas encore passées), par Pascal Choteau le 21 mai 2007 pour EspFor 2.4
function surligne_titre($string) {
	$string = textebrut($string);
	$qt = explode(" ", $string);
	$num = count ($qt);
		for ($i = 0; $i < $num; $i++) {
			if (strtolower($qt[$i]) != strtolower($_GET['recherche'])) $string_re .= $qt[$i]." ";
			else  $string_re .= "<span class=\"spip_surligne\">".$qt[$i]."</span> ";
	       }
	 return $string_re;
}

// filtre couper_chemin, permet de n'afficher que le nom du document (en supprimant le chemin et l'extension), par Pascal Choteau le 27 mai 2007 pour EspFor 2.4
function couper_chemin($chaine) {
	$longueur = strlen($chaine);
	$titre = substr($chaine,8,$longueur-12);
	return $titre;
}

// filtre etoiles associé aux résultats d'une recherche (je n'ai pas retrouvé la source!!! mes excuses pour l'auteur)
function etoiles($texte) {
	$point = $texte;
	$texte = "";
	$star="<img src=\"squelettes/images/etoile.png\">";
	if ($point > 2) {
		$texte= $star;
	}
	if ($point > 6) {
		$texte= $star."&nbsp;".$star ;
	}
	if ($point > 8) {
		$texte= $star."&nbsp;".$star."&nbsp;".$star ;
	}
	if ($point > 12) {
		$texte= $star."&nbsp;".$star."&nbsp;".$star."&nbsp;".$star ;
	}
	if ($point > 20) {
		$texte= $star."&nbsp;".$star."&nbsp;".$star."&nbsp;".$star."&nbsp;".$star ;
	}

return $texte;
}

// filtre nettoyer_article, permet de présenter un aperçu avant publication pour l'édition rapide depuis l'espace public (adaptation de la fonction de l'espace privé de SPIP)
function nettoyer_article($texte)
{
	include_spip('inc/texte');
	if (strlen($texte) < 10 ) {
		$erreur = _T('forum_attention_dix_caracteres');
		return $erreur;
	} else {
		$previsualisation = PtoBR(propre(supprimer_tags($texte)));
		return $previsualisation;
	}
}

// filtre onelettre dans "Tri alphabétique tout en SPIP" lundi 9 avril 2007, par echo http://www.spip-contrib.net/Tri-alphabetique-tout-en-Spip
function onelettre($texte) {
	$texte = $texte{0}; // première lettre
	// remplacement des caractères accentués
	// exemple trouvé là: 
	// http://be.php.net/manual/fr/function.strtr.php#52098
	$texte = strtr($texte, "\xA1\xAA\xBA\xBF\xC0\xC1\xC2\xC3\xC5\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xD0\xD1\xD2\xD3\xD4\xD5\xD8\xD9\xDA\xDB\xDD\xE0\xE1\xE2\xE3\xE5\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF8\xF9\xFA\xFB\xFD\xFF", "!ao?AAAAACEEEEIIIIDNOOOOOUUUYaaaaaceeeeiiiidnooooouuuyy");
	$texte = strtr($texte, array("\xC4"=>"Ae", "\xC6"=>"AE", "\xD6"=>"Oe", "\xDC"=>"Ue", "\xDE"=>"TH", "\xDF"=>"ss", "\xE4"=>"ae", "\xE6"=>"ae", "\xF6"=>"oe", "\xFC"=>"ue", "\xFE"=>"th"));
	$texte = strtoupper($texte); // tout en majuscules
	//if($texte!='&')
	return $texte;
}

// filtre agenda_memo2 EspFor 2.4 le 20 mai 2007 par Pascal Choteau adapté de la CONTRIBUTION sur Spip-contrib "Plugin Agenda" lundi 14 août 2006, par Cedric Morin http://www.spip-contrib.net/Plugin-Agenda et du filtre agenda_memo de SPIP
// ce filtre permet d'afficher une plage de date pour un article (entre date et date_redac)
function agenda_memo2($date_deb=0, $date_fin=0, $descriptif='', $titre='', $url='', $cal='')
{

  static $agenda = array();
  if (!$date_deb) return $agenda;
  $idatedeb = date_ical($date_deb);
$idatefin = date_ical($date_fin);
  $cal = trim($cal); // func_get_args (filtre alterner) rajoute \n !!!!
  $startday1=explode(' ',$date_deb);
	$startday1=$startday1['0'].' 00:00:00';
	$ts_startday1=strtotime($startday1);
	$ts_date_fin=strtotime($date_fin);
	$maxdays=365;
	while (($ts_startday1<$ts_date_fin)&&($maxdays-->0))
	{
		$day=date('Y-m-d H:i:s',$ts_startday1);
		$agenda[$cal][(date_anneemoisjour($day))][] =  array(
			'CATEGORIES' => $cal,
			'DTSTART' => $idatedeb,
			'DTEND' => $idatefin,
			'DESCRIPTION' => $descriptif,
			'SUMMARY' => $titre,
			'URL' => $url);
		$ts_startday1 += 26*3600; // le jour suivant : +26 h pour gerer les changements d'heure
		$ts_startday1 = mktime(0, 0, 0, date("m",$ts_startday1), 
		date("d",$ts_startday1), date("Y",$ts_startday1)); // et remise a zero de l'heure	
	}
  // toujours retourner vide pour qu'il ne se passe rien
  return "";
}

// filtre agenda_affiche2 EspFor 2.4 le 20 mai 2007 par Pascal Choteau adapté du filtre agenda_affiche de SPIP (fait appel à agenda_memo2)
function agenda_affiche2($i)
{
	include_spip('inc/filtre');
	include_spip('inc/agenda');
	include_spip('inc/minipres');
	$args = func_get_args();
	$nb = array_shift($args); // nombre d'evenements (on pourrait l'afficher)
	$sinon = array_shift($args);
	$type = array_shift($args);
	if (!$nb){ 
		return http_calendrier_init('', ($type != 'periode') ? $type : 'mois', '', '', str_replace('&amp;', '&', self()), $sinon);
	}	
	$agenda = agenda_memo2(0);
	$evt = array();
	foreach (($args ? $args : array_keys($agenda)) as $k) {  
		if (is_array($agenda[$k]))
		foreach($agenda[$k] as $d => $v) { 
			$evt[$d] = $evt[$d] ? (array_merge($evt[$d], $v)) : $v;
		}
	}
	$d = array_keys($evt);

	if (count($d)){
		$mindate = min($d);
		$start = strtotime($mindate);
	}
	else {  
		$mindate = ($j=_request('jour')) * ($m=_request('mois')) * ($a=_request('annee'));  
  		if ($mindate)
			$start = mktime(0,0,0, $m, $j, $a);
  		else $start = mktime(0,0,0);
	}
	if ($type != 'periode')
		$evt = array('', $evt);
	else {
		$min = substr($mindate,6,2);
		$max = $min + ((strtotime(max($d)) - $start) / (3600 * 24));
		if ($max < 31) $max = 0;
		$evt = array('', $evt, $min, $max);
		$type = 'mois';
	}
	return http_calendrier_init($start, $type, '', '', str_replace('&amp;', '&', self()), $evt);
}
?>